version: '3'


services:
  fluentd:
    build: ./docker/fluentd
    image: dlartigae/fluentd-elastic:latest
    restart: always
    container_name: fluentd
    depends_on:
      - elasticsearch
    ports:
      - 24224:24224
    volumes:
      - ./config/fluentd/fluentd-multiregex.conf:/fluentd/etc/fluent.conf

  elasticsearch:
    image: elasticsearch:7.4.2
    restart: always
    container_name: elasticsearch
    environment:
      cluster.name: docker-cluster
      discovery.type: single-node
      ES_JAVA_OPTS: "-Xms512m -Xmx512m"
    ports:
      - 9200:9200
      - 9300:9300

  kibana:
    image: kibana:7.4.2
    restart: always
    container_name: kibana
    ports:
      - 5601:5601

  server:
    build: ./docker/server
    image: dlartigae/py-server:latest
    hostname: python
    container_name: server
    environment:
      PYTHONUNBUFFERED: 1
    depends_on:
      - fluentd
    ports:
      - 8000:80
    logging:
      driver: fluentd
      options:
        fluentd-address: localhost:24224
        tag: "efk.{{.Name}}"
